com.google.gwt.resources.gss

## Class CssPrinter

- java.lang.Object
- - com.google.gwt.thirdparty.common.css.compiler.passes.UniformVisitor
  - - com.google.gwt.thirdparty.common.css.compiler.passes.CodePrinter
    - - com.google.gwt.thirdparty.common.css.compiler.passes.CompactPrinter
      - - com.google.gwt.resources.gss.CssPrinter

All Implemented Interfaces:
  com.google.gwt.thirdparty.common.css.compiler.ast.AtRuleHandler, com.google.gwt.thirdparty.common.css.compiler.ast.CssCompilerPass, com.google.gwt.thirdparty.common.css.compiler.ast.CssTreeVisitor

    public class CssPrinter
    extends com.google.gwt.thirdparty.common.css.compiler.passes.CompactPrinter

Visitor that converts the AST to a `String` that can be evaluated as a Java expression.

For example, the following GSS code

### Field Summary

### Fields inherited from class com.google.gwt.thirdparty.common.css.compiler.passes.CodePrinter

`buffer, visitController`

### Constructor Summary

Constructors
Constructor and Description
`CssPrinter(com.google.gwt.thirdparty.common.css.compiler.ast.CssNode node)`
`CssPrinter(com.google.gwt.thirdparty.common.css.compiler.ast.CssTree tree)`

### Method Summary

All Methods Instance Methods Concrete Methods
`protected void` `appendValueNode(com.google.gwt.thirdparty.common.css.compiler.ast.CssValueNode node)`
`boolean` `enterConditionalBlock(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalBlockNode node)`
`boolean` `enterConditionalRule(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalRuleNode node)`
`boolean` `enterTree(com.google.gwt.thirdparty.common.css.compiler.ast.CssRootNode root)`
`java.lang.String` `getCompactPrintedString()`
`void` `leaveConditionalBlock(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalBlockNode block)`
`void` `leaveConditionalRule(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalRuleNode node)`
`void` `leaveTree(com.google.gwt.thirdparty.common.css.compiler.ast.CssRootNode root)`
`void` `runPass()`

### Methods inherited from class com.google.gwt.thirdparty.common.css.compiler.passes.CompactPrinter

`enterArgumentNode, enterAttributeSelector, enterBlock, enterClassSelector, enterCombinator, enterCompositeValueNodeOperator, enterDeclaration, enterDeclarationBlock, enterDefinition, enterFontFace, enterFunctionNode, enterIdSelector, enterImportRule, enterKey, enterKeyframesRule, enterMediaRule, enterMediaTypeListDelimiter, enterPageRule, enterPageSelector, enterPseudoClass, enterPseudoElement, enterSelector, enterUnknownAtRule, enterValueNode, leaveCombinator, leaveCompositeValueNode, leaveDeclaration, leaveDeclarationBlock, leaveFunctionNode, leaveImportRule, leaveKey, leaveKeyBlock, leaveKeyframesRule, leaveMediaRule, leavePseudoClass, leaveSelector, leaveSelectorBlock, leaveUnknownAtRule, leaveValueNode, printCompactly, printCompactly`

### Methods inherited from class com.google.gwt.thirdparty.common.css.compiler.passes.CodePrinter

`enter, getOutputBuffer, leave, resetBuffer`

### Methods inherited from class com.google.gwt.thirdparty.common.css.compiler.passes.UniformVisitor

`enterComponent, enterCompositeValueNode, enterForLoop, enterImportBlock, enterKeyBlock, enterKeyframeRuleset, enterMixin, enterMixinDefinition, enterPropertyValue, enterProvideNode, enterRequireNode, enterRuleset, enterSelectorBlock, leaveArgumentNode, leaveAttributeSelector, leaveBlock, leaveClassSelector, leaveComponent, leaveCompositeValueNodeOperator, leaveDefinition, leaveFontFace, leaveForLoop, leaveIdSelector, leaveImportBlock, leaveKeyframeRuleset, leaveMediaTypeListDelimiter, leaveMixin, leaveMixinDefinition, leavePageRule, leavePageSelector, leavePropertyValue, leaveProvideNode, leavePseudoElement, leaveRequireNode, leaveRuleset, visit`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### CssPrinter

    public CssPrinter(com.google.gwt.thirdparty.common.css.compiler.ast.CssTree tree)

#### CssPrinter

    public CssPrinter(com.google.gwt.thirdparty.common.css.compiler.ast.CssNode node)

### Method Detail

#### enterTree

    public boolean enterTree(com.google.gwt.thirdparty.common.css.compiler.ast.CssRootNode root)

Specified by:
  `enterTree` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.CssTreeVisitor`
Overrides:
  `enterTree` in class `com.google.gwt.thirdparty.common.css.compiler.passes.UniformVisitor`

#### getCompactPrintedString

    public java.lang.String getCompactPrintedString()

Overrides:
  `getCompactPrintedString` in class `com.google.gwt.thirdparty.common.css.compiler.passes.CompactPrinter`

#### leaveTree

    public void leaveTree(com.google.gwt.thirdparty.common.css.compiler.ast.CssRootNode root)

Specified by:
  `leaveTree` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.CssTreeVisitor`
Overrides:
  `leaveTree` in class `com.google.gwt.thirdparty.common.css.compiler.passes.UniformVisitor`

#### runPass

    public void runPass()

Specified by:
  `runPass` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.CssCompilerPass`
Overrides:
  `runPass` in class `com.google.gwt.thirdparty.common.css.compiler.passes.CompactPrinter`

#### enterConditionalBlock

    public boolean enterConditionalBlock(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalBlockNode node)

Specified by:
  `enterConditionalBlock` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.CssTreeVisitor`
Overrides:
  `enterConditionalBlock` in class `com.google.gwt.thirdparty.common.css.compiler.passes.CompactPrinter`

#### leaveConditionalBlock

    public void leaveConditionalBlock(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalBlockNode block)

Specified by:
  `leaveConditionalBlock` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.CssTreeVisitor`
Overrides:
  `leaveConditionalBlock` in class `com.google.gwt.thirdparty.common.css.compiler.passes.UniformVisitor`

#### enterConditionalRule

    public boolean enterConditionalRule(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalRuleNode node)

Specified by:
  `enterConditionalRule` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.AtRuleHandler`
Overrides:
  `enterConditionalRule` in class `com.google.gwt.thirdparty.common.css.compiler.passes.UniformVisitor`

#### leaveConditionalRule

    public void leaveConditionalRule(com.google.gwt.thirdparty.common.css.compiler.ast.CssConditionalRuleNode node)

Specified by:
  `leaveConditionalRule` in interface `com.google.gwt.thirdparty.common.css.compiler.ast.AtRuleHandler`
Overrides:
  `leaveConditionalRule` in class `com.google.gwt.thirdparty.common.css.compiler.passes.UniformVisitor`

#### appendValueNode

    protected void appendValueNode(com.google.gwt.thirdparty.common.css.compiler.ast.CssValueNode node)

Overrides:
  `appendValueNode` in class `com.google.gwt.thirdparty.common.css.compiler.passes.CompactPrinter`